#property copyright "Copyright  2006-2009, ATRLAB [Andrew Opeyda]"
#property link      "www.ATRLAB.com info@atrlab.com"

#property indicator_chart_window

extern datetime Expiration = D'16.03.2019 03:00';
extern bool Reverse = FALSE;
extern double Multiplier = 1.0;
int gi_unused_92 = 0;
int gi_96 = 50;

int init() {
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int l_ind_counted_0 = IndicatorCounted();
   string ls_unused_4 = "";
   string ls_12 = "";
   if (Period() == PERIOD_H1) ls_12 = "H1";
   if (Period() == PERIOD_H4) ls_12 = "H4";
   if (Period() == PERIOD_M30) ls_12 = "M30";
   if (Period() == PERIOD_D1) ls_12 = "D1";
   DrawText("ind.symbol", 10, 10, C'0xE2,0x6B,0x09', 16, "Arial", Symbol(), 1);
   DrawText("ind.period", 110, 10, C'0xE2,0x6B,0x09', 16, "Arial", ls_12, 1);
   DrawText("ind.price", 8, 20, C'0xE2,0x6B,0x09', 28, "Arial black", DoubleToStr(Close[0], Digits), 1);
   DrawText("ind.time", 10, 65, Black, 12, "Fixedsys", TimeToStr(TimeCurrent()), 0);
   if (Symbol() == "USDJPY") {
      Reverse = TRUE;
      Multiplier = 100;
   }
   if (Symbol() == "USDCHF") {
      Reverse = TRUE;
      Multiplier = 1;
   }
   if (Symbol() == "AUDUSD") {
      Reverse = FALSE;
      Multiplier = 1;
   }
   if (Symbol() == "USDCAD") {
      Reverse = TRUE;
      Multiplier = 1;
   }
   DrawFuturesCodes();
   DrawPercentRate();
   return (0);
}

void DrawText(string as_0, int a_x_8, int a_y_12, color a_color_16, int a_fontsize_20, string a_fontname_24, string a_text_32, int ai_40) {
   string l_name_44 = as_0 + ".";
   ObjectDelete(l_name_44);
   ObjectCreate(l_name_44, OBJ_LABEL, 0, 0, 0);
   ObjectSet(l_name_44, OBJPROP_XDISTANCE, a_x_8);
   ObjectSet(l_name_44, OBJPROP_YDISTANCE, a_y_12);
   ObjectSet(l_name_44, OBJPROP_COLOR, a_color_16);
   ObjectSet(l_name_44, OBJPROP_BACK, FALSE);
   ObjectSetText(l_name_44, a_text_32, a_fontsize_20, a_fontname_24);
   l_name_44 = as_0;
   ObjectDelete(l_name_44);
   if (ai_40) {
      ObjectCreate(l_name_44, OBJ_LABEL, 0, 0, 0);
      ObjectSet(l_name_44, OBJPROP_XDISTANCE, a_x_8 + 1);
      ObjectSet(l_name_44, OBJPROP_YDISTANCE, a_y_12 + 1);
      ObjectSet(l_name_44, OBJPROP_COLOR, Black);
      ObjectSet(l_name_44, OBJPROP_BACK, FALSE);
      ObjectSetText(l_name_44, a_text_32, a_fontsize_20, a_fontname_24);
   }
}

int ShowFutures(string a_symbol_0, int ai_8) {
   double ld_12 = MarketInfo(a_symbol_0, MODE_ASK);
   double ld_20 = MarketInfo(a_symbol_0, MODE_BID);
   if (Reverse) {
      ld_12 = 1 / ld_12;
      ld_20 = 1 / ld_20;
   }
   ld_12 *= Multiplier;
   ld_20 *= Multiplier;
   string ls_unused_28 = "";
   double ld_36 = (Expiration - Time[0]) / 60 / 60 / 24;
   double ld_44 = (ld_20 - Ask) / Point;
   double ld_52 = MathMin(MarketInfo(Symbol(), MODE_SWAPLONG), MarketInfo(Symbol(), MODE_SWAPSHORT));
   double ld_60 = ld_44 / ld_36;
   string ls_68 = "";
   if (ld_12 > Ask) ls_68 = "p";
   if (ld_12 < Ask) ls_68 = "q";
   DrawInfo(ld_12, a_symbol_0, ld_36, ai_8, ls_68);
   return (0);
}

void DrawInfo(double ad_0, string as_8, int ai_unused_16, int ai_20, string as_24) {
   string ls_unused_32 = "";
   DrawText("ind.futures." + as_8, 10, ai_20, C'0x1D,0x94,0xF6', 14, "Arial", as_8 + " " + DoubleToStr(ad_0, Digits), 1);
   DrawText("ind.futures.signal." + as_8, 130, ai_20, C'0x1D,0x94,0xF6', 14, "Wingdings 3", as_24, 1);
}

void DrawPercentRate() {
   double l_swaplong_0 = MarketInfo(Symbol(), MODE_SWAPLONG);
   double l_swapshort_8 = MarketInfo(Symbol(), MODE_SWAPSHORT);
   string ls_16 = "";
   if (l_swaplong_0 < l_swapshort_8) ls_16 = "p";
   if (l_swaplong_0 > l_swapshort_8) ls_16 = "q";
   DrawText("ind.percentrate", 10, 120, C'0x1D,0x94,0xF6', 14, "Arial", "%Rate trend", 1);
   DrawText("ind.percentrate.signal", 130, 120, C'0x1D,0x94,0xF6', 14, "Wingdings 3", ls_16, 1);
}

void DrawFuturesCodes() {
   gi_96 = 81;
   string ls_0 = "6";
   if (Symbol() == "EURUSD") ls_0 = ls_0 + "E";
   if (Symbol() == "GBPUSD") ls_0 = ls_0 + "B";
   if (Symbol() == "USDJPY") ls_0 = ls_0 + "J";
   if (Symbol() == "USDCHF") ls_0 = ls_0 + "S";
   if (Symbol() == "AUDUSD") ls_0 = ls_0 + "A";
   if (Symbol() == "USDCAD") ls_0 = ls_0 + "C";
   if (Symbol() == "USDRUB") ls_0 = ls_0 + "R";
   if (Symbol() == "EURCHF") ls_0 = "RF";
   if (Symbol() == "EURGBP") ls_0 = "RP";
   if (Symbol() == "EURJPY") ls_0 = "RY";
   if (FutureAvaible(ls_0 + "F9")) DrawFutures(ls_0 + "F9");
   if (FutureAvaible(ls_0 + "G9")) DrawFutures(ls_0 + "G9");
   if (FutureAvaible(ls_0 + "H9")) DrawFutures(ls_0 + "H9");
   if (FutureAvaible(ls_0 + "J9")) DrawFutures(ls_0 + "J9");
   if (FutureAvaible(ls_0 + "K9")) DrawFutures(ls_0 + "K9");
   if (FutureAvaible(ls_0 + "M9")) DrawFutures(ls_0 + "M9");
   if (FutureAvaible(ls_0 + "N9")) DrawFutures(ls_0 + "N9");
   if (FutureAvaible(ls_0 + "Q9")) DrawFutures(ls_0 + "Q9");
   if (FutureAvaible(ls_0 + "U9")) DrawFutures(ls_0 + "U9");
   if (FutureAvaible(ls_0 + "V9")) DrawFutures(ls_0 + "V9");
   if (FutureAvaible(ls_0 + "X9")) DrawFutures(ls_0 + "X9");
   if (FutureAvaible(ls_0 + "Z9")) DrawFutures(ls_0 + "Z9");
}

bool FutureAvaible(string a_symbol_0) {
   double l_ask_8 = MarketInfo(a_symbol_0, MODE_ASK);
   if (l_ask_8 == 0.0) return (FALSE);
   return (TRUE);
}

void DrawFutures(string as_0) {
   ShowFutures(as_0, gi_96);
   gi_96 += 20;
}